diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/test/wifi-aggregation-test.cc ns-3.47/src/wifi/test/wifi-aggregation-test.cc
--- ns-3.46/src/wifi/test/wifi-aggregation-test.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/test/wifi-aggregation-test.cc	2026-02-16 16:08:49.877231000 -0800
@@ -44,6 +44,18 @@
 
 using namespace ns3;
 
+namespace
+{
+
+/// Map standard to aPSDUMaxLength
+const std::map<WifiStandard, uint32_t> maxPsduLengths = {
+    {WIFI_STANDARD_80211n, WIFI_PSDU_MAX_LENGTH_HT},
+    {WIFI_STANDARD_80211ac, WIFI_PSDU_MAX_LENGTH_VHT},
+    {WIFI_STANDARD_80211ax, WIFI_PSDU_MAX_LENGTH_HE},
+    {WIFI_STANDARD_80211be, WIFI_PSDU_MAX_LENGTH_EHT},
+};
+} // namespace
+
 /**
  * @ingroup wifi-test
  * @ingroup tests
@@ -93,6 +105,14 @@
     void EnqueuePkts(std::size_t count, uint32_t size, const Mac48Address& dest);
 
     /**
+     * Check the maximum PSDU size
+     *
+     * @param phy the PHY
+     * @param fem the HT frame exchange manager
+     */
+    void CheckMaxPsduSize(Ptr<WifiPhy> phy, Ptr<HtFrameExchangeManager> fem);
+
+    /**
      * @return the Best Effort QosTxop
      */
     Ptr<QosTxop> GetBeQueue() const;
@@ -388,15 +408,42 @@
 }
 
 void
+AmpduAggregationTest::CheckMaxPsduSize(Ptr<WifiPhy> phy, Ptr<HtFrameExchangeManager> fem)
+{
+    const auto expectedMaxPsduLength = maxPsduLengths.at(phy->GetStandard());
+    const auto mc = phy->GetMaxModulationClassSupported();
+
+    NS_TEST_EXPECT_MSG_EQ(phy->GetMaxPsduSize(mc),
+                          expectedMaxPsduLength,
+                          "Unexpected aPSDUMaxLength");
+
+    const auto maxAmpduSize = std::min(m_params.maxAmpduSize, expectedMaxPsduLength);
+    const auto recipient = Mac48Address("00:00:00:00:00:02");
+
+    auto isWithinAmpduSizeLimit = fem->IsWithinAmpduSizeLimit(maxAmpduSize, recipient, 0, mc);
+    NS_TEST_EXPECT_MSG_EQ(isWithinAmpduSizeLimit,
+                          true,
+                          "A-MPDU size limit check failed when the size is smaller than the limit");
+
+    isWithinAmpduSizeLimit = fem->IsWithinAmpduSizeLimit(maxAmpduSize + 1, recipient, 0, mc);
+    NS_TEST_EXPECT_MSG_EQ(isWithinAmpduSizeLimit,
+                          false,
+                          "A-MPDU size limit check failed when the size is larger than the limit");
+}
+
+void
 AmpduAggregationTest::DoRun()
 {
     /*
      * Test behavior when no other packets are in the queue
      */
+    auto phy = m_phys.at(SINGLE_LINK_OP_ID);
     auto fem = m_mac->GetFrameExchangeManager(SINGLE_LINK_OP_ID);
     auto htFem = DynamicCast<HtFrameExchangeManager>(fem);
     auto mpduAggregator = htFem->GetMpduAggregator();
 
+    CheckMaxPsduSize(phy, htFem);
+
     /*
      * Create a dummy packet of 1500 bytes and fill mac header fields.
      */
@@ -404,9 +451,9 @@
 
     auto peeked = GetBeQueue()->PeekNextMpdu(SINGLE_LINK_OP_ID);
     WifiTxParameters txParams;
-    txParams.m_txVector = m_mac->GetWifiRemoteStationManager()->GetDataTxVector(
-        peeked->GetHeader(),
-        m_phys.at(SINGLE_LINK_OP_ID)->GetChannelWidth());
+    txParams.m_txVector =
+        m_mac->GetWifiRemoteStationManager()->GetDataTxVector(peeked->GetHeader(),
+                                                              phy->GetChannelWidth());
     auto item = GetBeQueue()->GetNextMpdu(SINGLE_LINK_OP_ID, peeked, txParams, Time::Min(), true);
 
     auto mpduList = mpduAggregator->GetNextAmpdu(item, txParams, Time::Min());
@@ -455,9 +502,9 @@
 
     peeked = GetBeQueue()->PeekNextMpdu(SINGLE_LINK_OP_ID);
     txParams.Clear();
-    txParams.m_txVector = m_mac->GetWifiRemoteStationManager()->GetDataTxVector(
-        peeked->GetHeader(),
-        m_phys.at(SINGLE_LINK_OP_ID)->GetChannelWidth());
+    txParams.m_txVector =
+        m_mac->GetWifiRemoteStationManager()->GetDataTxVector(peeked->GetHeader(),
+                                                              phy->GetChannelWidth());
     item = GetBeQueue()->GetNextMpdu(SINGLE_LINK_OP_ID, peeked, txParams, Time::Min(), true);
 
     mpduList = mpduAggregator->GetNextAmpdu(item, txParams, Time::Min());
@@ -470,9 +517,9 @@
 
     peeked = GetBeQueue()->PeekNextMpdu(SINGLE_LINK_OP_ID);
     txParams.Clear();
-    txParams.m_txVector = m_mac->GetWifiRemoteStationManager()->GetDataTxVector(
-        peeked->GetHeader(),
-        m_phys.at(SINGLE_LINK_OP_ID)->GetChannelWidth());
+    txParams.m_txVector =
+        m_mac->GetWifiRemoteStationManager()->GetDataTxVector(peeked->GetHeader(),
+                                                              phy->GetChannelWidth());
     item = GetBeQueue()->GetNextMpdu(SINGLE_LINK_OP_ID, peeked, txParams, Time::Min(), true);
 
     mpduList = mpduAggregator->GetNextAmpdu(item, txParams, Time::Min());
@@ -549,16 +596,19 @@
      * is such that only two MSDUs can be aggregated. Therefore, the first MPDU we get contains
      * an A-MSDU of 2 MSDUs.
      */
+    auto phy = m_phys.at(SINGLE_LINK_OP_ID);
     auto fem = m_mac->GetFrameExchangeManager(SINGLE_LINK_OP_ID);
     auto htFem = DynamicCast<HtFrameExchangeManager>(fem);
     auto msduAggregator = htFem->GetMsduAggregator();
     auto mpduAggregator = htFem->GetMpduAggregator();
 
+    CheckMaxPsduSize(phy, htFem);
+
     auto peeked = GetBeQueue()->PeekNextMpdu(SINGLE_LINK_OP_ID);
     WifiTxParameters txParams;
-    txParams.m_txVector = m_mac->GetWifiRemoteStationManager()->GetDataTxVector(
-        peeked->GetHeader(),
-        m_phys.at(SINGLE_LINK_OP_ID)->GetChannelWidth());
+    txParams.m_txVector =
+        m_mac->GetWifiRemoteStationManager()->GetDataTxVector(peeked->GetHeader(),
+                                                              phy->GetChannelWidth());
     htFem->TryAddMpdu(peeked, txParams, Time::Min());
     auto item = msduAggregator->GetNextAmsdu(peeked, txParams, Time::Min());
 
@@ -581,9 +631,9 @@
 
     peeked = GetBeQueue()->PeekNextMpdu(SINGLE_LINK_OP_ID);
     txParams.Clear();
-    txParams.m_txVector = m_mac->GetWifiRemoteStationManager()->GetDataTxVector(
-        peeked->GetHeader(),
-        m_phys.at(SINGLE_LINK_OP_ID)->GetChannelWidth());
+    txParams.m_txVector =
+        m_mac->GetWifiRemoteStationManager()->GetDataTxVector(peeked->GetHeader(),
+                                                              phy->GetChannelWidth());
     htFem->TryAddMpdu(peeked, txParams, Time::Min());
     item = msduAggregator->GetNextAmsdu(peeked, txParams, Time::Min());
 
@@ -607,9 +657,9 @@
 
     peeked = GetBeQueue()->PeekNextMpdu(SINGLE_LINK_OP_ID);
     txParams.Clear();
-    txParams.m_txVector = m_mac->GetWifiRemoteStationManager()->GetDataTxVector(
-        peeked->GetHeader(),
-        m_phys.at(SINGLE_LINK_OP_ID)->GetChannelWidth());
+    txParams.m_txVector =
+        m_mac->GetWifiRemoteStationManager()->GetDataTxVector(peeked->GetHeader(),
+                                                              phy->GetChannelWidth());
 
     // Compute the first MPDU to be aggregated in an A-MPDU. It must contain an A-MSDU
     // aggregating two MSDUs
@@ -657,9 +707,9 @@
     // prepare another A-MPDU (e.g., for transmission on another link)
     peeked = GetBeQueue()->PeekNextMpdu(SINGLE_LINK_OP_ID, 0, psdu->GetAddr1(), mpduList.at(2));
     txParams.Clear();
-    txParams.m_txVector = m_mac->GetWifiRemoteStationManager()->GetDataTxVector(
-        peeked->GetHeader(),
-        m_phys.at(SINGLE_LINK_OP_ID)->GetChannelWidth());
+    txParams.m_txVector =
+        m_mac->GetWifiRemoteStationManager()->GetDataTxVector(peeked->GetHeader(),
+                                                              phy->GetChannelWidth());
 
     // Compute the first MPDU to be aggregated in an A-MPDU. It must contain an A-MSDU
     // aggregating two MSDUs
@@ -691,9 +741,9 @@
     // A-MSDU aggregation now fails because the first item in the queue contain A-MSDUs
     peeked = GetBeQueue()->PeekNextMpdu(SINGLE_LINK_OP_ID);
     txParams.Clear();
-    txParams.m_txVector = m_mac->GetWifiRemoteStationManager()->GetDataTxVector(
-        peeked->GetHeader(),
-        m_phys.at(SINGLE_LINK_OP_ID)->GetChannelWidth());
+    txParams.m_txVector =
+        m_mac->GetWifiRemoteStationManager()->GetDataTxVector(peeked->GetHeader(),
+                                                              phy->GetChannelWidth());
 
     htFem->TryAddMpdu(peeked, txParams, Time::Min());
     item = msduAggregator->GetNextAmsdu(peeked, txParams, Time::Min());
@@ -710,9 +760,9 @@
 
     peeked = GetBeQueue()->PeekNextMpdu(SINGLE_LINK_OP_ID);
     txParams.Clear();
-    txParams.m_txVector = m_mac->GetWifiRemoteStationManager()->GetDataTxVector(
-        peeked->GetHeader(),
-        m_phys.at(SINGLE_LINK_OP_ID)->GetChannelWidth());
+    txParams.m_txVector =
+        m_mac->GetWifiRemoteStationManager()->GetDataTxVector(peeked->GetHeader(),
+                                                              phy->GetChannelWidth());
 
     NS_TEST_EXPECT_MSG_EQ(peeked->GetHeader().IsQosAmsdu(),
                           false,
@@ -748,15 +798,16 @@
 };
 
 HeAggregationTest::HeAggregationTest(uint16_t bufferSize)
-    : AmpduAggregationTest("Check the correctness of 802.11ax aggregation operations, size=" +
-                               std::to_string(bufferSize),
-                           Params{.standard = WIFI_STANDARD_80211ax,
-                                  .nLinks = 1,
-                                  .dataMode = "HeMcs11",
-                                  .bufferSize = bufferSize,
-                                  .maxAmsduSize = 0,
-                                  .maxAmpduSize = 65535,
-                                  .txopLimit = Seconds(0)})
+    : AmpduAggregationTest(
+          "Check the correctness of 802.11ax aggregation operations, buffer size=" +
+              std::to_string(bufferSize),
+          Params{.standard = WIFI_STANDARD_80211ax,
+                 .nLinks = 1,
+                 .dataMode = "HeMcs11",
+                 .bufferSize = bufferSize,
+                 .maxAmsduSize = 0,
+                 .maxAmpduSize = 6500631,
+                 .txopLimit = Seconds(0)})
 {
 }
 
@@ -766,17 +817,21 @@
     /*
      * Test behavior when 300 packets are ready for transmission
      */
-    EnqueuePkts(300, 100, Mac48Address("00:00:00:00:00:02"));
+    const std::size_t numPackets = 300;
+    EnqueuePkts(numPackets, 100, Mac48Address("00:00:00:00:00:02"));
 
+    auto phy = m_phys.at(SINGLE_LINK_OP_ID);
     auto fem = m_mac->GetFrameExchangeManager(SINGLE_LINK_OP_ID);
     auto htFem = DynamicCast<HtFrameExchangeManager>(fem);
     auto mpduAggregator = htFem->GetMpduAggregator();
 
+    CheckMaxPsduSize(phy, htFem);
+
     auto peeked = GetBeQueue()->PeekNextMpdu(SINGLE_LINK_OP_ID);
     WifiTxParameters txParams;
-    txParams.m_txVector = m_mac->GetWifiRemoteStationManager()->GetDataTxVector(
-        peeked->GetHeader(),
-        m_phys.at(SINGLE_LINK_OP_ID)->GetChannelWidth());
+    txParams.m_txVector =
+        m_mac->GetWifiRemoteStationManager()->GetDataTxVector(peeked->GetHeader(),
+                                                              phy->GetChannelWidth());
     auto item = GetBeQueue()->GetNextMpdu(SINGLE_LINK_OP_ID, peeked, txParams, Time::Min(), true);
 
     auto mpduList = mpduAggregator->GetNextAmpdu(item, txParams, Time::Min());
@@ -786,7 +841,7 @@
     NS_TEST_EXPECT_MSG_EQ(mpduList.size(),
                           m_params.bufferSize,
                           "A-MPDU contains an unexpected number of MPDUs");
-    uint16_t expectedRemainingPacketsInQueue = 300 - m_params.bufferSize;
+    uint16_t expectedRemainingPacketsInQueue = numPackets - m_params.bufferSize;
     NS_TEST_EXPECT_MSG_EQ(GetBeQueue()->GetWifiMacQueue()->GetNPackets(),
                           expectedRemainingPacketsInQueue,
                           "Queue contains an unexpected number of MPDUs");
@@ -806,23 +861,25 @@
      * Constructor.
      *
      * @param bufferSize the size (in number of MPDUs) of the BlockAck buffer
+     * @param maxAmpduSize the maximum size (in bytes) allowed per A-MPDU
      */
-    EhtAggregationTest(uint16_t bufferSize);
+    EhtAggregationTest(uint16_t bufferSize, uint32_t maxAmpduSize);
 
   private:
     void DoRun() override;
 };
 
-EhtAggregationTest::EhtAggregationTest(uint16_t bufferSize)
-    : AmpduAggregationTest("Check the correctness of 802.11be aggregation operations, size=" +
-                               std::to_string(bufferSize),
-                           Params{.standard = WIFI_STANDARD_80211be,
-                                  .nLinks = 2,
-                                  .dataMode = "EhtMcs13",
-                                  .bufferSize = bufferSize,
-                                  .maxAmsduSize = 0,
-                                  .maxAmpduSize = 102000,
-                                  .txopLimit = Seconds(0)})
+EhtAggregationTest::EhtAggregationTest(uint16_t bufferSize, uint32_t maxAmpduSize)
+    : AmpduAggregationTest(
+          "Check the correctness of 802.11be aggregation operations, buffer size=" +
+              std::to_string(bufferSize) + ", max A-MPDU size=" + std::to_string(maxAmpduSize),
+          Params{.standard = WIFI_STANDARD_80211be,
+                 .nLinks = 2,
+                 .dataMode = "EhtMcs13",
+                 .bufferSize = bufferSize,
+                 .maxAmsduSize = 0,
+                 .maxAmpduSize = maxAmpduSize,
+                 .txopLimit = Seconds(0)})
 {
 }
 
@@ -830,27 +887,34 @@
 EhtAggregationTest::DoRun()
 {
     /*
-     * Test behavior when 1200 packets of 100 bytes each are ready for transmission. The max
-     * A-MPDU size limit (102000 B) is computed to have at most 750 MPDUs aggregated in a single
-     * A-MPDU (each MPDU is 130 B, plus 4 B of A-MPDU subframe header, plus 2 B of padding).
-     */
-    EnqueuePkts(1200, 100, Mac48Address("00:00:00:00:00:02"));
-    const std::size_t maxNMpdus = 750;
+     * Test behavior when 1200 packets of 100 bytes each are ready for transmission. In the first
+     * tests, the max A-MPDU size limit (102000 B) is computed to have at most 750 MPDUs aggregated
+     * in a single A-MPDU (each MPDU is 130 B, plus 4 B of A-MPDU subframe header, plus 2 B of
+     * padding). In the last test, the max A-MPDU size limit is the upper bound allowed by the
+     * standard (6500631 B), which allows to aggregate 1024 MPDUs (the buffer size) in a single
+     * A-MPDU.
+     */
+    const std::size_t numPackets = 1200;
+    EnqueuePkts(numPackets, 100, Mac48Address("00:00:00:00:00:02"));
+    const auto maxNMpdus = std::min<std::size_t>(m_params.maxAmpduSize / 136, m_params.bufferSize);
 
     for (uint8_t linkId = 0; linkId < m_params.nLinks; linkId++)
     {
+        auto phy = m_phys.at(linkId);
         auto fem = m_mac->GetFrameExchangeManager(linkId);
         auto htFem = DynamicCast<HtFrameExchangeManager>(fem);
         auto mpduAggregator = htFem->GetMpduAggregator();
         std::vector<Ptr<WifiMpdu>> mpduList;
 
+        CheckMaxPsduSize(phy, htFem);
+
         auto peeked = GetBeQueue()->PeekNextMpdu(linkId);
         if (peeked)
         {
             WifiTxParameters txParams;
-            txParams.m_txVector = m_mac->GetWifiRemoteStationManager()->GetDataTxVector(
-                peeked->GetHeader(),
-                m_phys.at(linkId)->GetChannelWidth());
+            txParams.m_txVector =
+                m_mac->GetWifiRemoteStationManager()->GetDataTxVector(peeked->GetHeader(),
+                                                                      phy->GetChannelWidth());
             auto item = GetBeQueue()->GetNextMpdu(linkId, peeked, txParams, Time::Min(), true);
 
             mpduList = mpduAggregator->GetNextAmpdu(item, txParams, Time::Min());
@@ -859,7 +923,7 @@
 
         uint16_t expectedRemainingPacketsInQueue;
 
-        if (m_params.bufferSize >= maxNMpdus)
+        if (m_params.bufferSize > maxNMpdus)
         {
             // two A-MPDUs are transmitted concurrently on the two links and together saturate
             // the transmit window
@@ -871,7 +935,7 @@
                 NS_TEST_EXPECT_MSG_EQ(mpduList.size(),
                                       maxNMpdus,
                                       "A-MPDU contains an unexpected number of MPDUs");
-                expectedRemainingPacketsInQueue = 1200 - maxNMpdus;
+                expectedRemainingPacketsInQueue = numPackets - maxNMpdus;
                 NS_TEST_EXPECT_MSG_EQ(GetBeQueue()->GetWifiMacQueue()->GetNPackets(),
                                       expectedRemainingPacketsInQueue,
                                       "Queue contains an unexpected number of MPDUs");
@@ -882,7 +946,7 @@
                 NS_TEST_EXPECT_MSG_EQ(mpduList.size(),
                                       m_params.bufferSize - maxNMpdus,
                                       "A-MPDU contains an unexpected number of MPDUs");
-                expectedRemainingPacketsInQueue = 1200 - m_params.bufferSize;
+                expectedRemainingPacketsInQueue = numPackets - m_params.bufferSize;
                 NS_TEST_EXPECT_MSG_EQ(GetBeQueue()->GetWifiMacQueue()->GetNPackets(),
                                       expectedRemainingPacketsInQueue,
                                       "Queue contains an unexpected number of MPDUs");
@@ -902,7 +966,7 @@
                 NS_TEST_EXPECT_MSG_EQ(mpduList.size(),
                                       m_params.bufferSize,
                                       "A-MPDU contains an unexpected number of MPDUs");
-                expectedRemainingPacketsInQueue = 1200 - m_params.bufferSize;
+                expectedRemainingPacketsInQueue = numPackets - m_params.bufferSize;
                 NS_TEST_EXPECT_MSG_EQ(GetBeQueue()->GetWifiMacQueue()->GetNPackets(),
                                       expectedRemainingPacketsInQueue,
                                       "Queue contains an unexpected number of MPDUs");
@@ -910,7 +974,7 @@
             case 1:
                 // no more MPDUs can be sent, aggregation fails
                 NS_TEST_EXPECT_MSG_EQ(mpduList.empty(), true, "MPDU aggregation did not fail");
-                expectedRemainingPacketsInQueue = 1200 - m_params.bufferSize;
+                expectedRemainingPacketsInQueue = numPackets - m_params.bufferSize;
                 NS_TEST_EXPECT_MSG_EQ(GetBeQueue()->GetWifiMacQueue()->GetNPackets(),
                                       expectedRemainingPacketsInQueue,
                                       "Queue contains an unexpected number of MPDUs");
@@ -1242,8 +1306,9 @@
     AddTestCase(new TwoLevelAggregationTest, TestCase::Duration::QUICK);
     AddTestCase(new HeAggregationTest(64), TestCase::Duration::QUICK);
     AddTestCase(new HeAggregationTest(256), TestCase::Duration::QUICK);
-    AddTestCase(new EhtAggregationTest(512), TestCase::Duration::QUICK);
-    AddTestCase(new EhtAggregationTest(1024), TestCase::Duration::QUICK);
+    AddTestCase(new EhtAggregationTest(512, 102000), TestCase::Duration::QUICK);
+    AddTestCase(new EhtAggregationTest(1024, 102000), TestCase::Duration::QUICK);
+    AddTestCase(new EhtAggregationTest(1024, 15523200), TestCase::Duration::QUICK);
     AddTestCase(new PreservePacketsInAmpdus(true), TestCase::Duration::QUICK);
     AddTestCase(new PreservePacketsInAmpdus(false), TestCase::Duration::QUICK);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/test/wifi-dynamic-bw-op-test.cc ns-3.47/src/wifi/test/wifi-dynamic-bw-op-test.cc
--- ns-3.46/src/wifi/test/wifi-dynamic-bw-op-test.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/test/wifi-dynamic-bw-op-test.cc	2026-02-16 16:08:49.877231000 -0800
@@ -483,7 +483,7 @@
      *                                            primary20
      */
     AddTestCase(
-        new WifiUseAvailBwTest({"{31, 320, BAND_6GHZ, 10}", "{15, 160, BAND_6GHZ, 7}"}, 160),
+        new WifiUseAvailBwTest({"{31, 320, BAND_6GHZ, 10}", "{15, 160, BAND_6GHZ, 7}"}, MHz_u{160}),
         TestCase::Duration::QUICK);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/test/wifi-error-rate-models-test.cc ns-3.47/src/wifi/test/wifi-error-rate-models-test.cc
--- ns-3.46/src/wifi/test/wifi-error-rate-models-test.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/test/wifi-error-rate-models-test.cc	2026-02-16 16:08:49.879231000 -0800
@@ -30,11 +30,11 @@
 NS_LOG_COMPONENT_DEFINE("WifiErrorRateModelsTest");
 
 static double
-FromRss(dBW_u rss)
+FromRss(dBm_u rss)
 {
     // SINR is based on receiver noise figure of 7 dB and thermal noise
     // of -100.5522786 dBm in this 22 MHz bandwidth at 290K
-    dBW_u noisePower = -100.5522786 + 7;
+    dBm_u noisePower = -100.5522786 + 7;
 
     dB_u sinr = rss - noisePower;
     // return SINR expressed as ratio
@@ -426,7 +426,7 @@
     WifiTxVector txVector;
 
     txVector.SetMode(mode);
-    txVector.SetTxPowerLevel(0);
+    txVector.SetTxPowerLevel(WIFI_MIN_TX_PWR_LEVEL);
     txVector.SetChannelWidth(MHz_u{20});
     txVector.SetNss(1);
     txVector.SetNTx(1);
@@ -656,8 +656,8 @@
  * map of PER values that have been manually computed for a given MCS, size (in bytes) and SNR (in
  * dB) in order to verify against the PER calculated by the model
  */
-std::map<std::pair<uint8_t /* mcs */, uint32_t /* size */>,
-         std::map<dB_u /* snr */, double /* per */>>
+const std::map<std::pair<uint8_t /* mcs */, uint32_t /* size */>,
+               std::map<dB_u /* snr */, double /* per */>>
     expectedTableValues = {
         /* MCS 0 - 1458 bytes */
         {std::make_pair(0, 1458),
@@ -1066,22 +1066,30 @@
     // Spot test some values returned from TableBasedErrorRateModel
     for (dB_u snr = -4; snr <= dB_u{30}; snr += dB_u{0.25})
     {
-        double expectedValue = 0;
+        double expectedPer = 0;
         if (m_mode.GetMcsValue() > ERROR_TABLE_BCC_MAX_NUM_MCS)
         {
             Ptr<YansErrorRateModel> yans = CreateObject<YansErrorRateModel>();
-            expectedValue =
+            expectedPer =
                 1 - yans->GetChunkSuccessRate(m_mode, txVector, std::pow(10, snr / 10), m_size * 8);
         }
         else
         {
-            auto it = expectedTableValues.find(std::make_pair(m_mode.GetMcsValue(), m_size));
-            if (it != expectedTableValues.end())
+            const auto cit = expectedTableValues.find(std::make_pair(m_mode.GetMcsValue(), m_size));
+            if (cit != expectedTableValues.cend())
             {
-                auto itValue = it->second.find(snr);
-                if (itValue != it->second.end())
+                // Lambda to find map key within tolerance (avoids floating-point comparison issues)
+                const auto& snrPerMap = cit->second;
+                const auto expectedIt = [&]() {
+                    constexpr dB_u tolerance{1e-6};
+                    const auto iter = snrPerMap.lower_bound(snr - tolerance);
+                    return (iter != snrPerMap.cend() && iter->first <= snr + tolerance)
+                               ? iter
+                               : snrPerMap.cend();
+                }();
+                if (expectedIt != snrPerMap.cend())
                 {
-                    expectedValue = itValue->second;
+                    expectedPer = expectedIt->second;
                 }
                 else
                 {
@@ -1090,15 +1098,15 @@
             }
             else
             {
-                NS_FATAL_ERROR("No expected value found for the combination MCS "
+                NS_FATAL_ERROR("No expected PER found for the combination MCS "
                                << +m_mode.GetMcsValue() << " and size " << m_size << " bytes");
             }
         }
         const auto per =
             1 - table->GetChunkSuccessRate(m_mode, txVector, std::pow(10, snr / 10), m_size * 8);
         NS_LOG_INFO(m_testName << ": snr=" << snr << "dB per=" << per
-                               << " expectedPER=" << expectedValue);
-        NS_TEST_ASSERT_MSG_EQ_TOL(per, expectedValue, 1e-5, "Not equal within tolerance");
+                               << " expectedPER=" << expectedPer);
+        NS_TEST_ASSERT_MSG_EQ_TOL(per, expectedPer, 1e-5, "Not equal within tolerance");
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/test/wifi-non-ht-dup-test.cc ns-3.47/src/wifi/test/wifi-non-ht-dup-test.cc
--- ns-3.46/src/wifi/test/wifi-non-ht-dup-test.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/test/wifi-non-ht-dup-test.cc	2026-02-16 16:08:49.881231000 -0800
@@ -331,7 +331,7 @@
 {
     NS_LOG_FUNCTION(this << channelWidth);
     WifiTxVector txVector = WifiTxVector(OfdmPhy::GetOfdmRate24Mbps(),
-                                         0,
+                                         WIFI_MIN_TX_PWR_LEVEL,
                                          WIFI_PREAMBLE_LONG,
                                          NanoSeconds(800),
                                          1,
@@ -744,7 +744,7 @@
 
     WifiTxVector txVector =
         WifiTxVector(OfdmPhy::GetOfdmRate54Mbps(), // use less robust modulation for test purpose
-                     0,
+                     WIFI_MIN_TX_PWR_LEVEL,
                      WIFI_PREAMBLE_LONG,
                      NanoSeconds(800),
                      1,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/test/wifi-operating-channel-test.cc ns-3.47/src/wifi/test/wifi-operating-channel-test.cc
--- ns-3.46/src/wifi/test/wifi-operating-channel-test.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/test/wifi-operating-channel-test.cc	2026-02-16 16:08:49.881231000 -0800
@@ -222,12 +222,12 @@
            true);
 
     RunOne("default 320 MHz OFDM channel operating on channel 31",
-           {{31, 0, 320, WIFI_PHY_BAND_6GHZ}},
+           {{31, MHz_u{0}, MHz_u{320}, WIFI_PHY_BAND_6GHZ}},
            WIFI_STANDARD_UNSPECIFIED,
            WIFI_PHY_BAND_UNSPECIFIED,
            false,
            WifiChannelWidthType::CW_320MHZ,
-           {{31, 6105, 320, WIFI_PHY_BAND_6GHZ, FrequencyChannelType::OFDM}});
+           {{31, MHz_u{6105}, MHz_u{320}, WIFI_PHY_BAND_6GHZ, FrequencyChannelType::OFDM}});
 }
 
 /**
@@ -428,7 +428,7 @@
     // TODO: logic should be changed to support passing BAND_UNSPECIFIED
     RunOne("{31, 0, BAND_6GHZ, 0}",
            WifiChannelWidthType::CW_320MHZ,
-           {{31, 6105, 320, WIFI_PHY_BAND_6GHZ}},
+           {{31, MHz_u{6105}, MHz_u{320}, WIFI_PHY_BAND_6GHZ}},
            0);
 
     // Test 80+80 MHz
@@ -480,7 +480,7 @@
     // TODO: logic should be changed to support passing BAND_UNSPECIFIED
     RunOne("{0, 320, BAND_6GHZ, 0}",
            WifiChannelWidthType::CW_320MHZ,
-           {{31, 6105, 320, WIFI_PHY_BAND_6GHZ}},
+           {{31, MHz_u{6105}, MHz_u{320}, WIFI_PHY_BAND_6GHZ}},
            0);
 }
 
@@ -539,7 +539,7 @@
                                               const WifiPhyOperatingChannel& channel)
 {
     WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs0(),
-                                         0,
+                                         WIFI_MIN_TX_PWR_LEVEL,
                                          WIFI_PREAMBLE_HE_SU,
                                          NanoSeconds(800),
                                          1,
